searchData={"items":[{"type":"module","title":"Weather","doc":"Gets and displays weather information.\n>","ref":"Weather.html"},{"type":"module","title":"API Key Needed {: .info} - Weather","doc":">\n> In order to use `Weather`, you'll need to create an account at [OpenWeatherMap](https://openweathermap.org/) and get an API key for the [One Call API 3.0](https://openweathermap.org/api/one-call-3) service.\n>\n> The service allows for 1,000 free API calls per day.","ref":"Weather.html#module-api-key-needed-info"},{"type":"function","title":"Weather.get/1","doc":"Fetches weather from the OpenWeatherMap API.","ref":"Weather.html#get/1"},{"type":"function","title":"Weather.get!/1","doc":"Fetches weather from the OpenWeatherMap API. Raises a `RuntimeError` if any problems are encountered.","ref":"Weather.html#get!/1"},{"type":"module","title":"Weather.API","doc":"Fetches weather data from the OpenWeatherMap API.","ref":"Weather.API.html"},{"type":"function","title":"Weather.API.fetch_location/2","doc":"Fetches location data (latitude, longitude, name, country) given a zip code.","ref":"Weather.API.html#fetch_location/2"},{"type":"function","title":"Weather.API.fetch_weather/1","doc":"Fetches weather data from the OpenWeatherMap API.","ref":"Weather.API.html#fetch_weather/1"},{"type":"module","title":"Weather.CLI","doc":"Provides a command-line interface for fetching weather data via the\nOpenWeatherMap API. This module is intended to be invoked as an escript.","ref":"Weather.CLI.html"},{"type":"function","title":"Weather.CLI.main/1","doc":"The main module function invoked by the escript.","ref":"Weather.CLI.html#main/1"},{"type":"type","title":"Weather.CLI.args/0","doc":"","ref":"Weather.CLI.html#t:args/0"},{"type":"module","title":"Weather.Colors","doc":"Provides ANSI color codes for use in the Weather module.","ref":"Weather.Colors.html"},{"type":"function","title":"Weather.Colors.colorize/2","doc":"Colorizes a string according to a color code.","ref":"Weather.Colors.html#colorize/2"},{"type":"function","title":"Weather.Colors.colorize_temp/2","doc":"Formats and colorizes a temperature.","ref":"Weather.Colors.html#colorize_temp/2"},{"type":"function","title":"Weather.Colors.default_color_codes/0","doc":"Returns the default ANSI color codes associated with temperature categories.","ref":"Weather.Colors.html#default_color_codes/0"},{"type":"function","title":"Weather.Colors.list/0","doc":"Prints colorized text with associated color codes.","ref":"Weather.Colors.html#list/0"},{"type":"function","title":"Weather.Colors.list_current/1","doc":"Prints the current color configuration.","ref":"Weather.Colors.html#list_current/1"},{"type":"function","title":"Weather.Colors.remove_ansi/1","doc":"Removes ANSI characters from a given string.","ref":"Weather.Colors.html#remove_ansi/1"},{"type":"type","title":"Weather.Colors.category/0","doc":"","ref":"Weather.Colors.html#t:category/0"},{"type":"type","title":"Weather.Colors.codes/0","doc":"","ref":"Weather.Colors.html#t:codes/0"},{"type":"module","title":"Weather.ComprehensiveReport","doc":"Generates a comprehensive weather report composed of subreports.","ref":"Weather.ComprehensiveReport.html"},{"type":"function","title":"Weather.ComprehensiveReport.generate/2","doc":"Create a comprehensive weather report composed of subreports.","ref":"Weather.ComprehensiveReport.html#generate/2"},{"type":"module","title":"Weather.DateUtils","doc":"Provides date display utilities.","ref":"Weather.DateUtils.html"},{"type":"function","title":"Weather.DateUtils.time_by_hour/3","doc":"Returns the time specific to the hour, displayed in 12-hour or 24-hour format.","ref":"Weather.DateUtils.html#time_by_hour/3"},{"type":"function","title":"Weather.DateUtils.time_by_minute/3","doc":"Returns the time specific to the minute, displayed in 12-hour or 24-hour format.","ref":"Weather.DateUtils.html#time_by_minute/3"},{"type":"function","title":"Weather.DateUtils.time_by_minute_with_day/3","doc":"Returns the time specific to the minute, displayed in 12-hour or 24-hour format, with the day.","ref":"Weather.DateUtils.html#time_by_minute_with_day/3"},{"type":"module","title":"Weather.Opts","doc":"The `Weather.Opts` struct.\n\nFields:\n\n  * `:appid` - a string representing the OpenWeatherMap API key.\n\n  * `:colors` - a boolean representing whether or not to colorize the output\n    of the hourly report. Defaults to true.\n\n  * `:color_codes` - a map representing temperature color codes. Defaults\n    to `Weather.Colors.default_color_codes/0`.\n\n  * `:every_n_hours` - an integer representing the hour interval at which data is\n    reported for the hourly report. Defaults to 3.\n\n  * `:feels_like` - a boolean representing whether to show the \"feels like\" temperature\n    instead of the actual temperature. Defaults to false.\n\n  * `:hide_alerts` - a boolean representing whether to hide weather alerts, even\n    when alerts are available. Defaults to false, which shows alerts if there\n    are any available.\n\n  * `:alert_titles_only` - a boolean representing whether to show only the titles\n    of weather alerts. Defaults to false, which shows titles along with full\n    alert descriptions.\n\n  * `:hours` - an integer representing the number of hours to report on for the\n    hourly report. Defaults to 12. Max is 48.\n\n  * `:latitude` - a float representing the latitude of your location.\n\n  * `:longitude` - a float representing the longitude of your location.\n\n  * `:test` - a string representing the type of fake weather data to return for\n    testing purposes. Options are \"clear\", \"rain\", \"storm\".\n\n  * `:twelve` - a boolean representing whether to use 12-hour time format for\n    the hourly report. Defaults to true. When false, 24-hour time format is used.\n\n  * `:units` - a string representing the units of measurement. Default is\n    \"imperial\" (Fahrenheit). Other options are \"metric\" (Celsius) and\n    \"standard\" (Kelvin).\n\n  * `:label` - An optional string representing the name of the location\n    for which weather data is being fetched. If present, the report will include\n    the label in the output. If not provided but a zip code is provided, the\n    label will be set to the name of the location associated with the zip code.","ref":"Weather.Opts.html"},{"type":"function","title":"Weather.Opts.new/1","doc":"Create a new `Weather.Opts` struct, applying defaults where necessary.","ref":"Weather.Opts.html#new/1"},{"type":"function","title":"Weather.Opts.new!/1","doc":"Create a new `Weather.Opts` struct, applying defaults where necessary.\n\nRaises an `ArgumentError` if invalid input is given.","ref":"Weather.Opts.html#new!/1"},{"type":"type","title":"Weather.Opts.parsed_arg/0","doc":"","ref":"Weather.Opts.html#t:parsed_arg/0"},{"type":"type","title":"Weather.Opts.parsed_args/0","doc":"","ref":"Weather.Opts.html#t:parsed_args/0"},{"type":"type","title":"Weather.Opts.t/0","doc":"","ref":"Weather.Opts.html#t:t/0"},{"type":"behaviour","title":"Weather.Report","doc":"A behaviour module for implementing weather reports.","ref":"Weather.Report.html"},{"type":"callback","title":"Weather.Report.generate/1","doc":"","ref":"Weather.Report.html#c:generate/1"},{"type":"module","title":"Weather.Report.Alerts","doc":"Generates a report for any active alerts.","ref":"Weather.Report.Alerts.html"},{"type":"function","title":"Weather.Report.Alerts.generate/1","doc":"Generate a report for any active alerts.","ref":"Weather.Report.Alerts.html#generate/1"},{"type":"module","title":"Weather.Report.Current","doc":"Generates a report for the current weather.","ref":"Weather.Report.Current.html"},{"type":"function","title":"Weather.Report.Current.generate/1","doc":"Generate a report for the current weather.","ref":"Weather.Report.Current.html#generate/1"},{"type":"module","title":"Weather.Report.Custom.FullMoon","doc":"A custom `Weather.Report` that prints when there's a full moon.","ref":"Weather.Report.Custom.FullMoon.html"},{"type":"function","title":"Weather.Report.Custom.FullMoon.generate/1","doc":"Generates a full moon report.","ref":"Weather.Report.Custom.FullMoon.html#generate/1"},{"type":"module","title":"Weather.Report.Hourly","doc":"Generates an hourly report up to 48 hours, reporting every N hours (starting now, N defaulting to 3).","ref":"Weather.Report.Hourly.html"},{"type":"function","title":"Weather.Report.Hourly.generate/1","doc":"Generate an hourly temperature report.","ref":"Weather.Report.Hourly.html#generate/1"},{"type":"module","title":"Weather.Report.RainHourly","doc":"Generates a report showing which hours rain is forecasted (up to 24 hours).","ref":"Weather.Report.RainHourly.html"},{"type":"function","title":"Weather.Report.RainHourly.generate/1","doc":"Generates a report showing which hours rain is forecasted (up to 24 hours).","ref":"Weather.Report.RainHourly.html#generate/1"},{"type":"module","title":"Weather.Report.RainMinutely","doc":"Generates a chart showing rain intensity each minute for the next hour.","ref":"Weather.Report.RainMinutely.html"},{"type":"function","title":"Weather.Report.RainMinutely.generate/1","doc":"Generates a chart showing rain intensity each minute for the next hour.","ref":"Weather.Report.RainMinutely.html#generate/1"},{"type":"module","title":"Weather.Report.SunriseSunset","doc":"Generates a report showing sunrise and sunset times.","ref":"Weather.Report.SunriseSunset.html"},{"type":"function","title":"Weather.Report.SunriseSunset.generate/1","doc":"Generates a sunrise and sunset report.","ref":"Weather.Report.SunriseSunset.html#generate/1"},{"type":"extras","title":"Weather","doc":"# ![Logo](https://raw.githubusercontent.com/spencerolson/weather/main/priv/static/images/logo.png \"Weather\") Weather\n\n[![Build\nStatus](https://github.com/spencerolson/weather/actions/workflows/elixir.yml/badge.svg)](https://github.com/spencerolson/weather/actions/workflows/elixir.yml) [![License](https://img.shields.io/hexpm/l/weather.svg)](https://github.com/spencerolson/weather/blob/main/LICENSE.md) [![Hex.pm](https://img.shields.io/hexpm/v/weather.svg)](https://hex.pm/packages/weather) [![Documentation](https://img.shields.io/badge/documentation-purple)](https://hexdocs.pm/weather)\n\n[![Run in Livebook](https://livebook.dev/badge/v1/black.svg)](https://livebook.dev/run?url=https%3A%2F%2Fgithub.com%2Fspencerolson%2Fweather%2Fblob%2Fmain%2FLIVEBOOK.livemd)\n\nAn Elixir library for fetching data from the [OpenWeatherMap One Call API 3.0](https://openweathermap.org/api/one-call-3) service.\n\nUse it as a dependency in your project:\n\n```elixir\nMix.install(\n  [{:weather, \"~> 0.4.0\"}]\n)\n\nopts = Weather.Opts.new!(test: \"rain\")\nWeather.API.fetch_weather(opts)\n# =>\n# {:ok,\n#  %Req.Response{\n#    status: 200,\n#    headers: %{},\n#    body: %{\n#      \"current\" => %{...},\n#      \"daily\" => %{...},\n#      \"hourly\" => %{...},\n#      \"minutely\" => %{...},\n#      ...\n#    }\n#  }\n# }\n\nWeather.get!(opts) |> IO.puts\n\n                   << 🌧️  7:28AM - 8:27AM >>\n\n[                                                    ....    ]\n[                                              ............  ]\n[                                    ........................]\n[                                   .........................]\n[                                 ...........................]\n[                                ............................]\n                +              +              +\n\n🌧️  8AM - 9AM, 10AM - 12PM\n\n🌞 6:01AM | 🌚 7:52PM\n\n66°  ⬇   65°  ⬆   67°  ⬆   73°  ⬇   71°\n7AM      10AM     1PM      4PM      7PM\n\n66° | moderate rain | 92% humidity\n\n# => :ok\n```\n\nor standalone as a command line interface:\n\n```bash\n$ weather --units metric --no-twelve\n\n🌞 06:08 | 🌚 19:42\n\n24°  ⬇   23°  ⬇   18°  ⬇   16°  ⬇   15°\n16       19       22       01       04\n\n25° | clear sky | 48% humidity\n```","ref":"readme.html"},{"type":"extras","title":"Features - Weather","doc":"- Access to raw API responses\n- Access to formatted rain reports\n- Customizable ANSI-colorized output\n- Detailed rain intensity forecast for the next hour\n- Weather alerts\n- Customizable length and interval for hourly weather\n- Customizable time (12 or 24 hour) and temp display (celsius, fahrenheit, kelvin)\n- Usable as a dependency or standalone CLI\n- Weather lookup by ZIP code and country code\n- Mock weather responses to test responses for varying conditions","ref":"readme.html#features"},{"type":"extras","title":"Getting Started - Weather","doc":"In order to fetch real weather data, you'll want to first create an API Key for OpenWeatherMap's [\"One Call API 3.0\"](https://openweathermap.org/api/one-call-3) service. However, if you're not ready to do that yet, you can always play around with `Weather` by passing the `test` option (for more information, see the [Options](#options) section below).","ref":"readme.html#getting-started"},{"type":"extras","title":"Creating an API Key - Weather","doc":"Follow the directions on OpenWeatherMap's [\"One Call API 3.0\"](https://openweathermap.org/api/one-call-3) page for creating an API Key. Up to 1,000 calls per day are provided for free.\n\nAfter creating your API Key, make sure to set your \"Calls per day (no more than)\" to 1,000 at your [subscriptions](https://home.openweathermap.org/subscriptions) page. This ensures you'll never go over the limit of the 1,000 free API calls per day (I believe the default is 2,000 which is a bit irritating).\n\nIt can take some time for your API key to become ready for use. I think it took a few hours for my key to become activated.\n\n### (Optional) Set environment variables for your API Key, Latitude, and Longitude\n\nSet the `OPENWEATHER_API_KEY`, `WEATHER_LATITUDE`, and `WEATHER_LONGITUDE` environment variables. With these set, you won't need to pass `api_key`, `latitude`, or `longitude` to [`Weather.Opts.new/1`] and it'll default to using these values.\n\nFor example, with these environment variables set you can simply:\n\n```elixir\nWeather.get!() |> IO.puts()\n\n🌞 6:09AM | 🌚 7:40PM\n\n76°  ⬆   77°  ⮕   77°  ⬇   68°  ⬇   64°\n12PM     3PM      6PM      9PM      12AM\n\n76° | clear sky | 51% humidity\n\n# => :ok\n```","ref":"readme.html#creating-an-api-key"},{"type":"extras","title":"Using `Weather` as a Dependency - Weather","doc":"Add `weather` to your list of dependencies in `mix.exs`\n\n```elixir\ndef deps do\n  [{:weather, \"~> 0.4.0\"}]\nend\n```\n\nand you're ready to go!\n\n```elixir\n# If you haven't created an OpenWeatherMap API Key yet, this can be:\n# opts = Weather.Opts.new!(test: \"rain\")\n#\n# If you've set the environment variables for your API key, latitude, and longitude,\n# this can be:\n# opts = Weather.Opts.new!()\nopts = Weather.Opts.new!(\n  api_key: \"your-openweather-api-key\",\n  latitude: 41.411835,\n  longitude: -75.665245\n)\n{:ok, response} = Weather.API.fetch_weather(opts)\n# =>\n# {:ok,\n#  %Req.Response{\n#    status: 200,\n#    headers: %{},\n#    body: %{\n#      \"current\" => %{...},\n#      \"daily\" => %{...},\n#      \"hourly\" => %{...},\n#      \"minutely\" => %{...},\n#      ...\n#    }\n#  }\n# }\n\n{sun_report, _, _} = Weather.Report.SunriseSunset.generate({[], response.body, opts})\nIO.puts(sun_report)\n🌞 6:20AM | 🌚 7:50PM\n# => :ok\n```\n\nSee [Options](#options) for the list of options you can pass to [`Weather.Opts.new/1`].\n\nAll available modules can be found on [hexdocs](https://hexdocs.pm/weather).","ref":"readme.html#using-weather-as-a-dependency"},{"type":"extras","title":"Using `Weather` as a Command Line Interface - Weather","doc":"1. Install the escript\n   ```bash\n   $ mix escript.install hex weather\n   ```\n2. Add the escript to your `$PATH` (more info [here](https://hexdocs.pm/mix/main/Mix.Tasks.Escript.Install.html))\n3. Use it from anywhere!\n\n   If you've created an OpenWeatherMap API Key:\n   ```bash\n   $ weather --api-key your-openweather-api-key --latitude 41.411835 --longitude -75.665245\n\n   🌞 6:20AM | 🌚 7:50PM\n\n   77°  ⮕   77°  ⬇   69°  ⬇   59°  ⬇   57°\n   1PM      4PM      7PM      10PM     1AM\n\n   77° | clear sky | 51% humidity\n\n   ```\n\n   If you haven't created an OpenWeatherMap API Key yet:\n   ```bash\n   $ weather --test clear\n\n   🌞 5:17AM | 🌚 8:25PM\n\n   76°  ⬇   74°  ⬇   64°  ⬇   60°  ⬇   58°\n   3PM      6PM      9PM      12AM     3AM\n\n   77° | scattered clouds | 37% humidity\n\n   ```\n\n   If you've set the environment variables for your API key, latitude, and longitude:\n   ```bash\n   $ weather\n\n   🌞 6:20AM | 🌚 7:50PM\n\n   77°  ⮕   77°  ⬇   69°  ⬇   59°  ⬇   57°\n   1PM      4PM      7PM      10PM     1AM\n\n   77° | clear sky | 51% humidity\n   ```\n\n   For a list of all available options, see:\n   ```bash\n   $ weather --help\n\n    \n   ```\n\n## \"Minutely\" Rain Chart\n\nWhen any rain is expected within the next hour, a rain chart will be output by [`Weather.Report.RainMinutely.generate/1`]. It looks something like:\n\n```bash\n                    << 🌧️ 12:28PM - 1:27PM >>\n\n [                                                            ]\n [                                                            ]\n [                    ........................................]\n [............................................................]\n [............................................................]\n [............................................................]\n                 +              +              +\n```\n\nFor each column, the number of dots corresponds with the rain intensity for that minute:\n- 0 dots = \"No Rain\"\n- 1 dot  = \"Very Light\" (< 0.25 mm/hr)\n- 2 dots = \"Light\" (>= 0.25 and < 1 mm/hr)\n- 3 dots = \"Moderate\" (>= 1 and < 4 mm/hr)\n- 4 dots = \"Heavy\" (>= 4 and < 16 mm/hr)\n- 5 dots = \"Very Heavy\" (>= 16 and < 50 mm/hr)\n- 6 dots = \"Violent\" (>= 50 mm/hr)\n\nThe `+` characters are 15-minute markers. So the first `+` is 15 minutes from now, the second `+` is 30 minutes from now, and the third `+` is 45 minutes from now.","ref":"readme.html#using-weather-as-a-command-line-interface"},{"type":"extras","title":"Options - Weather","doc":"Option names listed below are for the command line interface. All options can also be passed as a [Keyword list](https://hexdocs.pm/elixir/keywords-and-maps.html#keyword-lists) to [`Weather.Opts.new/1`]. Hyphens must be converted to underscores for the option names passed to [`Weather.Opts.new/1`]. For example, `Weather.Opts.new(hide_alerts: true)`\n\n*Boolean switches take no values. --someval sets the value to `true` and --no-someval sets the value to `false`.*\n\n- `--help` (`-h`): Prints the help message. (boolean)\n- `--hide-alerts` (`-l`): Hides weather alerts, even when alerts are available. Default is false, which shows alerts if there are any available. (boolean)\n- `--feels-like` (`-f`): Shows the 'feels like' temperature instead of the actual temperature. Defaults to false. (boolean)\n- `--alert-titles-only` (`-o`): Shows only the titles of weather alerts. Default is false, which shows titles along with full alert descriptions. (boolean)\n- `--colors` (`-c`): Enables colorized output for the hourly report. Defaults to true. (boolean)\n- `--color-codes` (`-d`): A comma-separated list of up to 10 color codes to use for colorized output. Values must be integers in the range of 0 to 255 inclusive, or '_' to use the default. Defaults to 202,214,226,148,39,51,15,245,88,9. Values correspond with the following categories: arctic, freezing, cold, chilly, cool, mild, warm, hot, very_hot, scorching. (string)\n- `--every` (`-e`): Sets the hour interval at which data is reported for the hourly report. Defaults to 3. (integer)\n- `--hours` (`-r`): Sets the number of hours to report on for the hourly report. Defaults to 12. Max is 48. (integer)\n- `--label` (`-b`): The name of the location for which weather data is being fetched. If present, the report will include - the label in the output. If not provided but a zip code is provided, the label will be set to the name of the location associated with the zip code. (string)\n- `--latitude` (`-t`): The latitude of the location for which to fetch weather data. (float)\n- `--longitude` (`-n`): The longitude of the location for which to fetch weather data. (float)\n- `--api-key` (`-a`): The OpenWeatherMap API key. (string)\n- `--units` (`-u`): The units in which to return the weather data. Options: \"metric\" (celsius), \"celsius\", \"imperial\" (fahrenheit), \"fahrenheit\", \"standard\" (kelvin), \"kelvin\". (string)\n- `--test` (`-s`): Fake weather data for testing purposes. Options: \"clear\", \"rain\", \"storm\". (string)\n- `--twelve` (`-w`): Enables 12-hour time format for the hourly report. Defaults to true. When false, 24-hour time format is used. (boolean)\n- `--zip` (`-z`): A zip code string to fetch weather data for. This can be used in place of latitude and longitude. For most accurate results format should be zip/post code and ISO 3166 country code divided by comma. See https://openweathermap.org/api/geocoding-api#direct_zip for more information. (string)","ref":"readme.html#options"},{"type":"extras","title":"Customization - Weather","doc":"","ref":"readme.html#customization"},{"type":"extras","title":"Custom Colors - Weather","doc":"```elixir\nWeather.Colors.list()\n# => prints available colors and their associated codes\n\npink = 201\ngray = 248\nWeather.Opts.new!(color_codes: %{cool: pink, warm: gray})\n```\n\nor as a command line interface:\n\n```bash\n$ weather --color-codes \"_,_,_,_,201,_,248,_,_,_\"\n```","ref":"readme.html#custom-colors"},{"type":"extras","title":"Adding a Custom Report - Weather","doc":"1. Define a module that implements the `Weather.Report` behaviour (defines `generate/1`).\n\n   ```elixir\n   defmodule Weather.Report.Custom.FullMoon do\n     @moduledoc \"\"\"\n     A custom `Weather.Report` that prints when there's a full moon.\n     \"\"\"\n\n     use Weather.Report\n\n     @full_moon_phase 0.5\n\n     @doc \"\"\"\n     Generates a full moon report.\n     \"\"\"\n     @impl Weather.Report\n     def generate({report, %{\"daily\" => [%{\"moon_phase\" => @full_moon_phase} | _]} = body, opts}) do\n       {\n         [\"🌝🌚 OMG FULL MOON TONIGHT 🌚🌝\" | report],\n         body,\n         opts\n       }\n     end\n\n     def generate(weather), do: weather\n   end\n   ```\n\n2. Add that module to the list of custom reports in your `config/config.exs`\n\n   ```elixir\n   config :weather, custom_reports: [Weather.Report.Custom.FullMoon]\n   ```\n\n3. Wait for a full moon...🌑🌒🌓🌔🌕\n\n5. Enjoy your customized weather report\n\n   ```elixir\n   Weather.get!() |> IO.puts()\n\n   🌝🌚 OMG FULL MOON TONIGHT 🌚🌝\n\n   🌞 5:17AM | 🌚 8:25PM\n\n   76°  ⬇   74°  ⬇   64°  ⬇   60°  ⬇   58°\n   3PM      6PM      9PM      12AM     3AM\n\n   77° | scattered clouds | 37% humidity\n\n   :ok\n   ```\n\n6. If you're feeling generous, issue a [pull request](https://github.com/spencerolson/weather/pulls) to have your custom report added to the repo so others can use it! :D Please place the report in `lib/weather/report/custom/`. See `lib/weather/report/custom/full_moon.ex` for an example.","ref":"readme.html#adding-a-custom-report"},{"type":"extras","title":"Examples - Weather","doc":"All examples below assume the api key, latitude, and longitude environment variables have been set (see [(Optional) Set environment variables for your API Key, Latitude, and Longitude\n](#optional-set-environment-variables-for-your-api-key-latitude-and-longitude))","ref":"readme.html#examples"},{"type":"extras","title":"Fetch weather using a ZIP code (no latitude or longitude needed) - Weather","doc":"```bash\n$ weather --zip E14,GB --no-twelve --units metric\n\nLondon\n\n🌞 06:22 | 🌚 19:33\n\n19°  ⬆   21°  ⬇   20°  ⬇   17°  ⮕   17°\n13       16       19       22       01\n\n19° | clear sky | 76% humidity\n\nYELLOW RAIN WARNING (Sat 21:00 - Sun 18:00)\nWhilst there remains some uncertainty with exact details, areas of heavy and at times thundery rain are expected to spread north, then west, across England and Wales from this evening and overnight. These areas of heavy rain may become more persistent across western areas during Sunday daytime whilst slow-moving heavy showers and thunderstorms are likely to develop further east.\n\n```\n\nFetching weather by ZIP code will result in _two_ API calls to OpenWeather; one to get the location data for that ZIP, and one to get the weather.","ref":"readme.html#fetch-weather-using-a-zip-code-no-latitude-or-longitude-needed"},{"type":"extras","title":"Fetch weather with results in Celsius and using 24-hour time. - Weather","doc":"```bash\n$ weather --units celsius --no-twelve\n\n🌞 06:07 | 🌚 19:39\n\n26°  ⬆   27°  ⮕   27°  ⬇   23°  ⬇   21°\n12       15       18       21       00\n\n26° | broken clouds | 44% humidity\n\n```","ref":"readme.html#fetch-weather-with-results-in-celsius-and-using-24-hour-time"},{"type":"extras","title":"Fetch weather for every hour for the next 5 hours - Weather","doc":"```bash\n$ weather --every 1 --hours 5\n\n🌞 6:07AM | 🌚 7:39PM\n\n79°  ⮕   79°  ⬆   80°  ⬆   81°  ⬆   82°  ⮕   82°\n12PM     1PM      2PM      3PM      4PM      5PM\n\n79° | broken clouds | 44% humidity\n\n```","ref":"readme.html#fetch-weather-for-every-hour-for-the-next-5-hours"},{"type":"extras","title":"Use fake storm data, showing only titles (hiding descriptions) for alerts - Weather","doc":"```bash\n$ weather --test storm --alert-titles-only\n\n                   << 🌧️ 8:28PM - 9:27PM >>\n\n[                                                            ]\n[.........       ...............     ........................]\n[............................................................]\n[............................................................]\n[............................................................]\n[............................................................]\n                +              +              +\n\n🌧️ 9PM - 2AM\n\n🌞 5:44AM | 🌚 8:42PM\n\n77°  ⬇   73°  ⬇   70°  ⬇   68°  ⬆   72°\n8PM      11PM     2AM      5AM      8AM\n\n77° | very heavy rain | 76% humidity\n\nFLOOD WATCH (Tue 5:00PM - Wed 7:00AM)\n\nTORNADO WATCH (Tue 7:48PM - Tue 9:00PM)\n\nSEVERE THUNDERSTORM WARNING (Tue 8:12PM - Tue 9:30PM)\n\nSEVERE THUNDERSTORM WARNING (Tue 7:42PM - Tue 8:45PM)\n\nSEVERE THUNDERSTORM WARNING (Tue 8:17PM - Tue 8:45PM)\n\n```","ref":"readme.html#use-fake-storm-data-showing-only-titles-hiding-descriptions-for-alerts"},{"type":"extras","title":"Fetch weather, adding a label and removing ANSI colors from the output - Weather","doc":"```bash\n$ weather --label \"Home Sweet Home\" --no-colors\n\nHome Sweet Home\n\n🌞 6:07AM | 🌚 7:39PM\n\n80°  ⬆   81°  ⮕   81°  ⬇   74°  ⬇   69°\n12PM     3PM      6PM      9PM      12AM\n\n80° | broken clouds | 43% humidity\n\n```","ref":"readme.html#fetch-weather-adding-a-label-and-removing-ansi-colors-from-the-output"},{"type":"extras","title":"Get the latitude, longitude, and name of a location by ZIP code (`iex` only) - Weather","doc":"```elixir\nopts = Weather.Opts.new!(zip: \"60618,US\")\nopts.latitude\n# => 41.9464\nopts.longitude\n# => -87.7042\nopts.label\n# => \"Chicago\"\n```","ref":"readme.html#get-the-latitude-longitude-and-name-of-a-location-by-zip-code-iex-only"},{"type":"extras","title":"View the temperature thresholds for colorized output (`iex` only) - Weather","doc":"When viewed in iex, you will see different colors for each temp in the output (you can't see them in this README because markdown doesn't support ANSI colors).\n\n```elixir\nWeather.Colors.list_current()\n\nCurrent Color Configuration (temps in fahrenheit)\n\n-10°\n0°\n33°\n40°\n50°\n60°\n70°\n80°\n90°\n100°\n# => :ok\n```","ref":"readme.html#view-the-temperature-thresholds-for-colorized-output-iex-only"},{"type":"extras","title":"License - Weather","doc":"MIT License\n\nCopyright (c) 2024 Spencer Olson\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.\n\n[`Weather.Opts.new/1`]: https://hexdocs.pm/weather/Weather.Opts.html#new/1\n[`Weather.Report.RainMinutely.generate/1`]: https://hexdocs.pm/weather/Weather.Report.RainMinutely.html#generate/1","ref":"readme.html#license"},{"type":"extras","title":"Weather Livebook","doc":"# Weather Livebook\n\n```elixir\nMix.install(\n  [{:weather, \"~> 0.4.0\"}]\n)\n```","ref":"livebook.html"},{"type":"extras","title":"Getting Started - Weather Livebook","doc":"","ref":"livebook.html#getting-started"},{"type":"extras","title":"Fetching Fake Data - Weather Livebook","doc":"<!-- livebook:{\"break_markdown\":true} -->\n\nFirst, let's make sure our dependencies installed correctly and ensure we can fetch some fake weather data. For this step, we don't need an OpenWeather API Token.\n\n```elixir\nopts = Weather.Opts.new!(test: \"rain\")\n{:ok, fake_response} = Weather.API.fetch_weather(opts)\nfake_response.body\n```","ref":"livebook.html#fetching-fake-data"},{"type":"extras","title":"Fetching Real Data - Weather Livebook","doc":"<!-- livebook:{\"break_markdown\":true} -->\n\n1. Create an API Key for the OpenWeather One Call API 3.0 [here](https://openweathermap.org/api/one-call-3)\n2. Try running the block of code below. It will fail and you will see a message that looks like ```Missing secret \"OPENWEATHER_API_KEY\"``` with an \"Add secret\" button. Click the \"Add Secret\" button.\n3. Enter your API key in the \"Value\" input (leave the \"Name\" input with the prefilled name of \"OPENWEATHER_API_KEY\"). Click \"+Add\".\n4. Reevaluate the block of code below. If everything worked correctly, you should see a \"success!!\" return value.\n\n```elixir\napi_key = System.fetch_env!(\"LB_OPENWEATHER_API_KEY\")\n\"success!!\"\n```\n\nNow that we've configured our API Key, we can fetch some real weather data:\n\n```elixir\nopts =\n  Weather.Opts.new!(\n    api_key: api_key,\n    zip: \"30-003,PL\",\n    units: \"metric\",\n    twelve: false\n  )\n\n{:ok, real_response} = Weather.API.fetch_weather(opts)\nreal_response.body\n```\n\nIf you don't care about the raw response and just want some pretty output, you can use `Weather.get!/1`:\n\n```elixir\nopts\n|> Weather.get!()\n|> IO.puts()\n```","ref":"livebook.html#fetching-real-data"},{"type":"extras","title":"Examples - Weather Livebook","doc":"Setup:\n\n```elixir\napi_key = System.fetch_env!(\"LB_OPENWEATHER_API_KEY\")\n\nopts =\n  Weather.Opts.new!(\n    api_key: api_key,\n    latitude: 50.05905800533713,\n    longitude: 19.937632449794567,\n    label: \"Kraków\",\n    units: \"metric\",\n    twelve: false\n  )\n```\n\nFetch weather for every hour for the next 5 hours:\n\n```elixir\n%Weather.Opts{opts | every_n_hours: 1, hours: 5}\n|> Weather.get!()\n|> IO.puts()\n```\n\nLookup the latitude, longitude, and name of a location by ZIP code:\n\n```elixir\no = Weather.Opts.new!(api_key: api_key, zip: \"60618,US\")\n{o.latitude, o.longitude, o.label}\n```\n\nView the temp in Fahrenheit using 12-hour time, for the next 48 hours, every 6 hours, using custom colors:\n\n```elixir\n%Weather.Opts{\n  opts\n  | units: \"imperial\",\n    twelve: true,\n    hours: 48,\n    every_n_hours: 6,\n    color_codes: %{\n      arctic: 30,\n      freezing: 31,\n      cold: 32,\n      chilly: 33,\n      cool: 34,\n      mild: 35,\n      warm: 36,\n      hot: 37,\n      very_hot: 38,\n      scorching: 39\n    }\n}\n|> Weather.get!()\n|> IO.puts()\n```","ref":"livebook.html#examples"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}